SetLevel

;find level address	
	LD A,(LevelNr)
	LD HL,LevelAddrs-2
SetLevel2	
	INC HL
	INC HL
	DEC A
	JR NZ,SetLevel2	
	
	LD E,(HL)
	INC HL
	LD D,(HL)
	LD (CurrentLevelData),DE		;store level data

; clear board - which will at start copy of level data	and will clear during the game
	LD HL,Gameboard
	LD B,81
	XOR A
SetLevel3	
	LD (HL),A
	INC HL
	DJNZ SetLevel3	

;copy level data to the game board
	LD A,(BoardSize2)
	LD HL,Gameboard	
	EX DE,HL			;HL - source:current level data DE - dest:gameboard
	LD C,A
	LD B,0
	LDIR
	
;cursor position
	XOR A
	LD (CursorX),A
	LD (CursorY),A	
	RET	
	
;--------------------------
DrawLevel
;DE - level address
	LD HL,(BorderCorner)
	LD DE,33
	ADD HL,DE
	LD (BoardPos),HL

	LD DE,(CurrentLevelData)
	
	LD A,(BoardSize)
	LD B,A
	LD C,A

DrawLevel3
	PUSH HL
	PUSH BC
	
DrawLevel4	
	PUSH HL
	PUSH BC
	PUSH DE
	CALL FindJewelAddress
	CALL DrawJewel
	POP DE
	POP BC
	POP HL
	
	INC L				;position of next jewel
	INC L
	INC DE				;next jewel nr
	
	DJNZ DrawLevel4	
	
	POP BC				;restore width
	POP HL				;restore line bwginning address
	CALL OneCharDown
	CALL OneCharDown
	DEC C
	JR NZ,DrawLevel3
	
	RET

;---------------
FindJewelAddress
	PUSH HL
	LD A,(DE)			;jewel nr
	LD HL,Jewel1-33
	LD DE,33
		
FindJewelAddress2
	ADD HL,DE
	DEC A
	JR NZ,FindJewelAddress2
	EX HL,DE			;address into DE
	POP HL	
	RET

	
;---------------------------
Gameboard	
	REPT 81
	.BYTE 0
	ENDR
	
		
	
;---------------------------
;level addresses

LevelAddrs
	.WORD Level1
	.WORD Level2
	.WORD Level3
	.WORD Level4
	.WORD Level5
	.WORD Level6
	.WORD Level7
	.WORD Level8
	.WORD Level9
	.WORD Level10
	.WORD Level11
	.WORD Level12
	.WORD Level13
	.WORD Level14
	.WORD Level15
	.WORD Level16
	.WORD Level17
	.WORD Level18
	.WORD Level19
	.WORD Level20
	.WORD Level21
	.WORD Level22
	.WORD Level23
	.WORD Level24
	.WORD Level25
	.WORD Level26
	.WORD Level27
	.WORD Level28
	.WORD Level29
	.WORD Level30
	
	
;---------------------------
;level data
Level1
 .BYTE 6,5,7,3,8,6
 .BYTE 1,1,6,2,1,3
 .BYTE 2,1,6,5,1,3
 .BYTE 6,8,3,3,6,3
 .BYTE 8,5,3,2,11,5
 .BYTE 1,2,2,11,11,3
 
Level2
 .BYTE 3,3,5,10,8,5
 .BYTE 1,7,10,7,5,1
 .BYTE 6,5,1,10,4,5
 .BYTE 6,3,3,7,5,7
 .BYTE 4,8,5,3,3,4
 .BYTE 3,5,3,8,7,3 
 
Level3
 .BYTE 4,4,1,8,1,4
 .BYTE 4,4,1,3,1,1
 .BYTE 9,9,8,8,8,8
 .BYTE 4,9,5,3,7,11
 .BYTE 5,4,8,3,5,1
 .BYTE 4,7,4,7,7,1 
 
Level4
 .BYTE 1,1,7,6,6,11
 .BYTE 3,4,3,3,4,11
 .BYTE 7,7,7,1,6,6
 .BYTE 11,11,7,1,3,10
 .BYTE 3,10,1,3,4,1
 .BYTE 7,7,7,6,6,10

Level5
 .BYTE 11,11,3,7,3,5
 .BYTE 2,2,6,5,2,11
 .BYTE 6,9,3,1,3,5
 .BYTE 9,3,5,3,9,1
 .BYTE 9,9,5,7,3,1
 .BYTE 6,7,3,6,6,7

Level6
 .BYTE 3,1,7,1,3,6
 .BYTE 5,7,6,2,2,5
 .BYTE 6,3,7,7,5,6
 .BYTE 1,1,10,6,3,1
 .BYTE 1,1,6,6,6,6
 .BYTE 1,3,1,1,6,1
 
Level7
 .BYTE 7,2,2,10,10,1
 .BYTE 7,5,1,5,6,1
 .BYTE 7,6,4,7,5,2
 .BYTE 5,2,7,7,7,5
 .BYTE 4,3,10,4,4,2
 .BYTE 7,2,6,6,6,7
 
Level8
 .BYTE 1,1,4,8,1,5
 .BYTE 4,11,4,8,1,5
 .BYTE 1,7,6,6,8,7
 .BYTE 1,2,6,1,1,5
 .BYTE 4,2,6,11,2,11
 .BYTE 4,11,1,7,4,1

Level9
 .BYTE 5,5,5,7,1,7
 .BYTE 2,6,11,6,1,3
 .BYTE 3,1,1,1,3,11
 .BYTE 5,1,2,2,3,5
 .BYTE 6,3,7,6,1,3
 .BYTE 4,4,1,6,4,1

Level10
 .BYTE 2,1,4,6,4,4
 .BYTE 5,5,8,6,5,4
 .BYTE 1,2,10,1,7,4
 .BYTE 7,7,8,1,7,10
 .BYTE 1,10,4,1,5,10
 .BYTE 2,1,8,5,5,8 
 
Level11
 .BYTE 4,8,3,8,2,8,6,3
 .BYTE 11,8,10,8,2,8,1,3
 .BYTE 4,6,5,1,5,8,1,3
 .BYTE 10,1,1,1,1,10,10,10
 .BYTE 9,6,9,6,5,9,6,5
 .BYTE 10,6,6,2,4,11,2,5
 .BYTE 2,9,4,4,2,8,8,8
 .BYTE 4,4,3,9,6,10,11,3
 
Level12 
 .BYTE 11,1,6,11,11,11,4,4
 .BYTE 5,11,7,2,3,7,4,6
 .BYTE 5,10,10,11,2,10,11,10
 .BYTE 10,2,10,6,2,5,10,5
 .BYTE 10,8,6,5,5,10,10,2
 .BYTE 10,2,11,6,10,10,5,10
 .BYTE 1,1,6,1,1,1,10,10
 .BYTE 10,4,6,8,8,4,5,4
 
Level13
 .BYTE 5,9,10,8,9,5,5,3
 .BYTE 10,2,10,6,4,9,9,3
 .BYTE 2,3,2,6,4,5,9,11
 .BYTE 11,7,7,6,2,9,2,2
 .BYTE 9,4,4,6,2,8,8,5
 .BYTE 3,3,2,7,8,6,7,5
 .BYTE 2,4,4,4,2,8,8,10
 .BYTE 5,9,5,3,5,9,9,11 

Level14
 .BYTE 2,9,2,5,1,6,2,7
 .BYTE 2,9,3,1,6,3,6,7
 .BYTE 4,4,5,8,5,4,7,6
 .BYTE 7,10,9,9,7,6,2,7
 .BYTE 3,1,1,7,3,4,7,3
 .BYTE 1,6,10,10,1,9,7,4
 .BYTE 7,7,3,3,7,6,7,6
 .BYTE 6,10,6,6,6,4,6,6
 
Level15
 .BYTE 1,3,2,5,7,2,10,1
 .BYTE 1,4,4,10,8,10,5,5
 .BYTE 10,1,6,7,2,1,10,5
 .BYTE 2,6,1,6,7,1,7,2
 .BYTE 4,2,2,10,3,3,2,3
 .BYTE 1,6,2,1,6,5,4,10
 .BYTE 4,4,4,2,4,7,10,4
 .BYTE 5,3,6,5,8,5,4,3
 
Level16
 .BYTE 11,11,3,2,7,2,5,3
 .BYTE 4,7,4,1,2,5,6,7
 .BYTE 7,11,2,6,11,2,5,1
 .BYTE 5,7,4,1,3,2,1,3
 .BYTE 5,5,2,1,6,11,3,5
 .BYTE 7,2,4,1,7,2,8,6
 .BYTE 7,11,7,10,10,7,5,3
 .BYTE 4,5,2,10,6,6,10,7
 
Level17
 .BYTE 2,8,6,6,6,6,11,11
 .BYTE 4,10,8,10,2,8,6,4
 .BYTE 10,10,9,5,7,6,4,10
 .BYTE 7,8,10,7,5,6,4,6
 .BYTE 10,7,4,2,6,10,4,10
 .BYTE 10,5,4,7,9,1,10,5
 .BYTE 1,1,9,9,7,7,7,9
 .BYTE 2,8,4,2,6,2,9,2
 
Level18
 .BYTE 2,1,1,1,6,6,6,7
 .BYTE 7,1,2,4,4,6,7,6
 .BYTE 5,6,2,9,10,6,10,3
 .BYTE 1,3,2,5,7,6,11,7
 .BYTE 5,11,6,2,7,7,7,3
 .BYTE 7,1,9,9,4,6,11,3
 .BYTE 4,4,1,1,7,1,5,5
 .BYTE 2,1,4,1,4,7,6,7

Level19
 .BYTE 3,6,3,4,1,9,7,7
 .BYTE 5,3,5,8,10,5,5,6
 .BYTE 5,11,11,7,5,6,10,3
 .BYTE 1,3,9,5,8,6,5,9
 .BYTE 5,5,5,4,10,6,11,4
 .BYTE 7,11,4,7,1,5,7,4
 .BYTE 6,5,7,7,1,5,9,6
 .BYTE 1,3,6,1,6,9,11,6

Level20
 .BYTE 7,10,10,7,7,8,8,7
 .BYTE 7,2,4,6,4,10,4,2
 .BYTE 6,1,8,8,1,11,11,1
 .BYTE 7,5,10,1,7,7,5,8
 .BYTE 7,7,4,4,5,2,1,7
 .BYTE 8,5,6,7,3,7,8,8
 .BYTE 3,3,5,3,6,2,11,3
 .BYTE 3,1,6,3,5,2,2,5

Level21
 .BYTE 11,7,6,2,3,3,9,7,2
 .BYTE 6,8,6,6,2,5,6,6,2
 .BYTE 8,6,1,2,11,10,4,6,10
 .BYTE 7,2,9,2,4,9,3,4,10
 .BYTE 8,2,3,2,6,8,9,6,5
 .BYTE 2,11,5,11,2,6,6,11,11
 .BYTE 1,10,8,3,9,7,8,10,1
 .BYTE 11,2,6,11,7,5,6,11,8
 .BYTE 2,6,9,8,4,8,6,2,10

Level22
 .BYTE 8,7,2,2,9,9,2,8,6
 .BYTE 8,9,11,11,11,4,2,2,2
 .BYTE 10,6,5,6,9,1,10,8,6
 .BYTE 5,11,9,4,11,4,11,4,4
 .BYTE 10,7,1,6,8,4,5,6,8
 .BYTE 5,11,6,6,1,1,1,3,1
 .BYTE 1,1,9,3,11,8,5,8,2
 .BYTE 1,7,1,11,3,11,4,11,3
 .BYTE 5,5,11,2,9,2,11,4,4

Level23
 .BYTE 11,11,8,3,8,6,6,6,1
 .BYTE 8,8,6,4,6,2,7,6,1
 .BYTE 4,4,11,4,11,8,6,9,1
 .BYTE 4,3,11,4,3,1,3,5,4
 .BYTE 11,4,10,6,7,3,8,11,11
 .BYTE 1,3,4,4,6,5,3,4,9
 .BYTE 4,2,2,7,3,6,8,10,1
 .BYTE 3,7,10,3,4,3,8,5,6
 .BYTE 8,7,7,8,11,8,11,6,4

Level24
 .BYTE 9,10,6,6,6,9,9,10,10
 .BYTE 9,2,10,9,8,3,1,7,3
 .BYTE 1,7,9,6,4,8,8,5,1
 .BYTE 1,9,3,1,5,10,4,1,9
 .BYTE 9,6,9,1,8,2,6,8,6
 .BYTE 10,7,10,8,7,9,8,8,10
 .BYTE 6,10,3,4,7,9,4,4,5
 .BYTE 10,3,3,3,6,8,8,10,10
 .BYTE 1,1,1,4,8,2,6,4,1

Level25
 .BYTE 8,7,7,7,7,7,2,4,2
 .BYTE 8,6,6,11,8,7,8,8,7
 .BYTE 6,7,7,11,6,7,4,6,11
 .BYTE 8,10,8,1,10,5,8,11,7
 .BYTE 5,5,10,8,8,8,3,1,10
 .BYTE 11,10,11,11,7,1,11,8,11
 .BYTE 7,5,4,8,1,4,5,7,7
 .BYTE 3,2,11,10,10,3,4,4,4
 .BYTE 2,2,11,5,2,2,3,2,11
 
Level26
 .BYTE 10,11,10,7,10,2,11,3,6
 .BYTE 5,1,5,1,3,4,1,5,11
 .BYTE 10,3,1,8,3,1,11,11,5
 .BYTE 4,4,4,5,7,6,1,2,4
 .BYTE 3,7,3,1,1,3,4,3,4
 .BYTE 8,3,11,8,10,11,8,3,7
 .BYTE 8,1,2,10,1,1,10,2,6
 .BYTE 3,5,4,5,2,3,8,3,2
 .BYTE 5,5,10,10,6,3,8,2,6
 
Level27 
 .BYTE 3,1,2,1,1,6,2,3,3
 .BYTE 2,3,3,4,2,4,4,9,3
 .BYTE 7,4,3,11,7,8,3,3,1
 .BYTE 5,7,4,2,5,4,4,6,8
 .BYTE 5,8,7,3,4,4,5,7,5
 .BYTE 11,11,5,10,2,8,11,6,11
 .BYTE 11,4,4,5,4,8,8,9,5
 .BYTE 4,2,4,3,2,1,8,2,1
 .BYTE 8,4,8,3,7,1,3,10,7
 
Level28
 .BYTE 4,4,11,4,3,2,11,2,3
 .BYTE 2,5,11,10,4,3,7,7,4
 .BYTE 4,8,9,9,5,4,5,8,5
 .BYTE 9,7,8,4,7,8,8,11,8
 .BYTE 2,11,6,11,9,2,2,3,2
 .BYTE 6,2,5,11,8,10,5,11,6
 .BYTE 7,5,5,5,7,5,3,5,8
 .BYTE 7,5,8,7,7,10,2,3,7
 .BYTE 3,5,11,7,5,6,11,8,3
 
Level29
 .BYTE 7,1,8,6,8,2,11,7,2
 .BYTE 6,8,1,2,2,7,10,2,1
 .BYTE 1,1,11,9,3,5,8,1,9
 .BYTE 2,1,2,2,2,7,3,7,8
 .BYTE 3,2,7,1,4,2,9,6,4
 .BYTE 3,5,10,9,8,1,6,5,8
 .BYTE 9,1,4,3,9,1,8,1,1
 .BYTE 6,1,1,4,1,7,10,7,2
 .BYTE 2,2,10,10,5,7,11,8,10 
 
Level30
 .BYTE 4,10,2,4,2,6,1,1,5
 .BYTE 3,4,7,6,5,11,2,8,6
 .BYTE 10,4,2,11,7,6,5,7,6
 .BYTE 10,10,7,9,8,3,6,7,5
 .BYTE 9,7,6,3,1,3,1,7,7
 .BYTE 9,7,6,9,8,8,10,10,8
 .BYTE 5,4,3,5,5,8,8,9,5
 .BYTE 6,7,6,11,2,8,5,5,5
 .BYTE 3,8,9,6,2,6,9,6,8
 
PasswordData
 .BYTE 4,9,10,1
 .BYTE 4,10,2,4
 .BYTE 6,1,6,10
 .BYTE 2,3,9,7
 .BYTE 3,9,7,8
 .BYTE 5,5,1,3
 .BYTE 2,7,6,1
 .BYTE 7,6,3,9
 .BYTE 6,4,7,9
 .BYTE 2,2,5,2
 .BYTE 9,4,9,1
 .BYTE 5,1,10,6
 .BYTE 8,7,1,3
 .BYTE 9,7,1,5
 .BYTE 7,6,7,5
 .BYTE 5,3,2,7
 .BYTE 3,2,6,9
 .BYTE 9,10,4,3
 .BYTE 6,4,3,7
 .BYTE 9,4,4,6
 .BYTE 4,10,7,6
 .BYTE 3,5,4,8
 .BYTE 1,1,3,8
 .BYTE 2,5,2,1
 .BYTE 9,8,2,8
 .BYTE 7,8,6,5
 .BYTE 7,1,4,8
 .BYTE 9,5,9,3
 .BYTE 7,9,7,2
 .BYTE 6,9,3,8



