MoveCursor
	CALL GetPlayerInput
	LD C,A
	LD A,(BoardSize)
	DEC A
	LD B,A	
	
;go right	
	BIT 0,C
	JR Z,MoveCursor2
	
	LD HL,CursorX
	LD A,(HL)
	CP B				;edge?
	JR Z,MoveCursor2	
	INC (HL)

MoveCursor2
;go left	
	BIT 1,C
	JR Z,MoveCursor3
	
	LD HL,CursorX
	LD A,(HL)
	OR A				;edge?
	JR Z,MoveCursor3	
	DEC (HL)

MoveCursor3
;go up	
	BIT 3,C
	JR Z,MoveCursor4
	
	LD HL,CursorY
	LD A,(HL)
	OR A				;edge?
	JR Z,MoveCursor4	
	DEC (HL)

MoveCursor4
;go down	
	BIT 2,C
	JR Z,MoveCursor5
	
	LD HL,CursorY
	LD A,(HL)
	CP B				;edge?
	JR Z,MoveCursor5	
	INC (HL)

MoveCursor5
	BIT 4,C
	CALL NZ,Select
	RET
	
;----------------------------
Select	
	LD A,(SelectedJewel)
	OR A
	JP NZ,SelectSecond

Select2	
;store coordinates	
	LD A,(CursorX)
	LD (SelectedX),A
	LD B,A
	
	LD A,(CursorY)
	LD (SelectedY),A
	LD C,A
	
	CALL FindJewel			;A - nr of jewel under cursor
	OR A					;nothing under cursor?
	RET Z
	
	LD (SelectedJewel),A	;store jewel nr
	CALL SelectionSound
	RET
	
;-----------------------------------
SelectSecond
;check if clicking on already selected jewel, in that case deselect it
	LD A,(CursorX)
	LD B,A		
	LD A,(CursorY)
	LD C,A	
				
	LD A,(SelectedX)		
	CP B
	JR NZ,SelectSecond2
	
					
	LD A,(SelectedY)		
	CP C
	JR NZ,SelectSecond2

	XOR A					;coordianates the same
	LD (SelectedJewel),A	;clear selection and end
	CALL SelectionSound
	RET
	
SelectSecond2
;check if clicking on empty field, if so do nothing
	
	PUSH BC
	CALL FindJewel			;BC already pointing to coordidates
	POP BC
	OR A
	RET Z					;do nothing if no jewel
	
;check if clicking on other type jewel than 1st selection, if so ->change selection	
	LD D,A
	LD A,(SelectedJewel)
	CP D
	JR Z,SelectSecond3


	JP ChangeSelection		;jewel under cursor becomes new selected item	
	
	
;clicked jewel must be in the same row or collumn to clear jewels	
SelectSecond3	
	LD A,(SelectedX)
	CP B					;compare to cursor pos
	JP Z,ClearCol
	
	LD A,(SelectedY)
	CP C					;compare to cursor pos
	JP Z,ClearRow

	JP ChangeSelection		;no common row or collumn, change selection



;----------------
ChangeSelection
	LD A,174
	LD (DrawCursor_SMD),A	;XOR (HL) for clearing
	CALL MarkSelectedJewel	;clear selection of old jewel
	JP Select2				;select new jewel
	
	
	
;----------------------------
FindJewel
;BC - coordinates in table
	LD HL,Gameboard
	LD A,(BoardSize)
	LD E,A
	LD D,0					;DE - board size
	
;X coordinate	
	LD A,B
	OR A
	JR Z,FindJewel3
FindJewel2
	INC HL
	DJNZ FindJewel2	

;Y coordinate	
FindJewel3	
	LD A,C
	OR A
	JR Z,FindJewel5

FindJewel4
	ADD HL,DE
	DEC C
	JR NZ,FindJewel4

FindJewel5
	LD A,(HL)
	RET	
	
	
;----------------------------
ClearCol
	LD A,(CursorY)
	LD C,A
	LD A,(SelectedY)
	LD B,A
	CP C
	JR NC,ClearCol2			;make sure that C is smaller,B bigger
	
	LD A,C					;swap if necessary
	LD C,B
	LD B,A

ClearCol2
	PUSH BC
	LD A,C
	LD (TopmostY),A			;store for later use
	LD A,(CursorX)
	LD B,A
	CALL BoardXYtoHL		;HL - coords of 1st top jewel in the collumn
	POP BC	

	LD A,B
	SUB C
	INC A
	LD C,A					;C - nr of jewels in the collumn

 PUSH HL
 PUSH BC
	
	
	LD B,8					;nr of anim frames
	LD DE,Explosion1	

ClearCol3
	HALT
	HALT
	HALT
	PUSH HL					;store address of collumn beginning
	PUSH BC	
	PUSH DE
	
	LD A,B					;color
	DEC A

	SLA C					;height (nr of jewels*2)
	LD B,2					;width
	
	CALL PaintArea
	
	POP DE
	POP BC
	POP HL
	
	PUSH HL
	PUSH BC
	
ClearCol4
	XOR A
	OUT (254),A
	PUSH HL
	PUSH DE
	PUSH BC
	LD A,16
	OUT (254),A
		
		
	LD BC,2*256+2
	CALL DrawSprite
	
	POP BC
	POP DE
	POP HL
	
	CALL OneCharDown		;position of next jewel
	CALL OneCharDown
	DEC C
	JR NZ,ClearCol4			;draw all explosions
	
	POP BC					
	
	EX HL,DE				;next anim frame address into DE
	LD DE,32
	ADD HL,DE
	EX HL,DE
	POP HL					;restore row beginning
	
	DJNZ ClearCol3
	
 POP BC
 POP HL
;paint empty area with white attribute
 	PUSH BC
 	LD A,71
 	SLA C					;height (nr of jewels*2)
	LD B,2					;width
	CALL PaintArea			
	POP BC
	
;clear jewels in the table
	PUSH BC
	LD A,(CursorX)
	LD B,A
	LD A,(TopmostY)			
	LD C,A					
	CALL FindJewel			;sets HL to jewel address
	POP BC					;restore C - width
	
	LD A,(BoardSize)		;going one jewel down means
	LD E,A					;adding board side to current jewel offset
	LD D,0
	
	XOR A
ClearCol5					
	LD (HL),A
	ADD HL,DE
	DEC C					;C - number of jewels
	JR NZ,ClearCol5
		
	LD (SelectedJewel),A	;no more selected jewel	
	RET		

TopmostY	.BYTE 0	
	
;----------------------------
ClearRow
	LD A,(CursorX)
	LD B,A
	LD A,(SelectedX)
	LD C,A
	CP B
	JR NC,ClearRow2			;make sure that B is smaller,C bigger
	
	LD A,C					;swap if necessary
	LD C,B
	LD B,A

ClearRow2	
	PUSH BC
	LD A,B
	LD (LeftmostX),A		;store for later use
	LD A,(CursorY)
	LD C,A
	CALL BoardXYtoHL		;HL - coords of 1st jewel in the row
	POP BC
	
	LD A,C
	SUB B
	INC A
	LD C,A					;C - nr of jewels in the row
	
 PUSH HL
 PUSH BC
	
	
	LD B,8					;nr of anim frames
	LD DE,Explosion1	

ClearRow3
	HALT
	HALT
	HALT
	PUSH HL					;store address of row beginning
	PUSH BC	
	PUSH DE
	
	LD A,B					;color
	DEC A
	
	LD B,C					;width
	SLA B
	LD C,2					;height
	
	CALL PaintArea
	
	POP DE
	POP BC
	POP HL
	
	PUSH HL
	PUSH BC
	
ClearRow4
	XOR A
	OUT (254),A
	PUSH HL
	PUSH DE
	PUSH BC
	LD A,16
	OUT (254),A
		
		
	LD BC,2*256+2
	CALL DrawSprite
	
	POP BC
	POP DE
	POP HL
	
	INC L					;position of next jewel
	INC L
	DEC C
	JR NZ,ClearRow4			;draw all explosions
	
	POP BC					
	
	EX HL,DE				;next anim frame address into DE
	LD DE,32
	ADD HL,DE
	EX HL,DE
	POP HL					;restore row beginning
	
	DJNZ ClearRow3
	
 POP BC
 POP HL
;paint empty area with white attribute
 	PUSH BC
 	LD A,71
 	LD B,C					;width (nr of jewels*2)
	SLA B
	LD C,2					;height
	CALL PaintArea			
	POP BC
	
;clear jewels in the table
	PUSH BC
	LD A,(LeftmostX)
	LD B,A
	LD A,(CursorY)			
	LD C,A					
	CALL FindJewel			;sets HL to jewel address
	POP BC					;restore C - width
	
	XOR A
ClearRow5					
	LD (HL),A
	INC HL
	DEC C					;C - number of jewels
	JR NZ,ClearRow5
		
	
	LD (SelectedJewel),A	;no more selected jewel	
	RET	
LeftmostX	.BYTE 0	