StartMenu
	CALL ClearScreen
			

	LD HL,18432+5
	LD DE,MenuText
	CALL TypeText
	LD HL,18432+71
	CALL DrawMenuArrow
	
	CALL 49152				;music
	
	JR StartMenu_Keys
	
;read menu keys	
StartMenu2
	LD BC,63486; keys 1-5
	IN A,(C)
	
	BIT 0,A
	JR Z,StartMenu_Keys
	
	BIT 1,A
	JR Z,StartMenu_Kempston
	
	BIT 2,A
	JR Z,StartMenu_Sinclair

	BIT 3,A
	JP Z,EnterPassword	
	
	BIT 4,A
	JR Z,StartMenu_Start
	
	JR StartMenu2

;----	
StartMenu_Keys
	XOR A
	LD (GameControl),A
	LD HL,18432+71
	CALL DrawMenuArrow
	CALL SelectionSound
	JR StartMenu2
	
;----	
StartMenu_Kempston
	LD A,1
	LD (GameControl),A
	LD HL,18432+103
	CALL DrawMenuArrow
	CALL SelectionSound
	JR StartMenu2	
	
;----	
StartMenu_Sinclair
	LD A,2
	LD (GameControl),A
	LD HL,18432+135
	CALL DrawMenuArrow
	CALL SelectionSound
	JR StartMenu2		
	
;----	
StartMenu_Start
	CALL SelectionSound
	RET	
	
;-----------
DrawMenuArrow
	PUSH HL
	LD HL,18432+71
	LD BC,1*256+3
	CALL ClearArea
	LD HL,18432+71
	LD BC,1*256+3
	LD A,65
	CALL PaintArea
	POP HL
	
	LD DE,MenuArrow
	LD BC,1*256+1
	CALL DrawSprite
	RET
	
MenuArrow
	.BYTE	  8, 12,238,239,238, 12,  8,  0
	
	
;----------------------------------	
GetPlayerInput
	LD A,(GameControl)
	
	OR A
	JR Z,GetPlayerInput_Keyboard
	
	CP 1
	JP Z,GetPlayerInput_Kempston
	
	JP GetPlayerInput_Sinclair


GetPlayerInput_Keyboard
;the aim is to set bits of A register as it would be kempston joystick input
	LD D,0
	LD BC,57342; O,P	
	IN A,(C)
	CPL
	AND 00000011B
	LD D,A
	LD BC,64510;Q
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	RLA
	OR D		
	LD D,A		
	LD BC,65022;A
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	OR D
	LD D,A
	LD BC,32766
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	RLA
	RLA
	OR D ;ready
	LD E,A
	LD (PlayerInput),A
	RET

;-------	
GetPlayerInput_Kempston
	LD BC,31
	IN A,(C)
	LD (PlayerInput),A
	RET	

;-------
GetPlayerInput_Sinclair
	LD BC,0xeffe
	IN A,(C)
	CPL
	LD B,0
	
	BIT 3,A
	JR Z,ReadSinclair2
	SET 0,B

ReadSinclair2
	BIT 4,A
	JR Z,ReadSinclair3
	SET 1,B
	
ReadSinclair3
	BIT 1,A
	JR Z,ReadSinclair4
	SET 3,B

ReadSinclair4
	BIT 2,A
	JR Z,ReadSinclair5
	SET 2,B

ReadSinclair5
	BIT 0,A
	JR Z,ReadSinclair6
	SET 4,B

ReadSinclair6
	LD A,B
	LD (PlayerInput),A
	RET
	
	
;----------------------------------		
NewLevel
	LD A,(LevelNr)
	CP 31					;end of game
	JP Z,GameWin
	LD (LevelNr),A

;type level text	
;set level nr for typing
	LD B,0
NewLevel2
	INC B
	SUB 10
	JR NC,NewLevel2
	DEC B
	ADD A,10
	
;write ones
	LD HL,LevelTxt+7
	ADD A,30				;digit code
	LD (HL),A
;write tens	
	DEC HL
	LD A,B
	ADD A,30
	
	CP 30					;don't write 0, write space instead
	JR NZ,NewLevel3	
	LD A,27					;space code
	
NewLevel3	
	LD (HL),A
	CALL ClearScreen	
	LD HL,18432+107
	LD DE,LevelTxt
	CALL TypeText

	CALL DrawPassword
	
;set background color and size
	LD A,(LevelNr)	
	LD B,1
	LD D,6
	LD E,36
	LD HL,16384+137
	CP 11
	JR C,NewLewel6	
	
	LD B,4
	LD D,8
	LD E,64
	LD HL,16384+71
	CP 21
	JR C,NewLewel6	
	
	LD B,2
	LD D,9
	LD E,81
	LD HL,16384+38
	
NewLewel6
	LD A,B
	LD (BackgroundColor),A
	LD A,D
	LD (BoardSize),A
	LD A,E
	LD (BoardSize2),A
	LD (BorderCorner),HL
	LD B,150
	CALL Wait
	JP Start2
	
;--------------------------
DrawPassword
	
	LD DE,PasswordData-4
	LD A,(LevelNr)
DrawPassword1				;find passowrd for current level
	INC DE
	INC DE
	INC DE
	INC DE
	DEC A
	JR NZ,DrawPassword1	
	
	LD HL,18432+200
	LD B,4					;nr of jewels
DrawPassword2
	PUSH HL
	PUSH BC
	PUSH DE
	
	PUSH HL					;find jewel sprite
	LD HL,JewelsPassword-33
	LD A,(DE)
	LD DE,33
DrawPassword3	
	ADD HL,DE
	DEC A
	JR NZ,DrawPassword3	
	EX HL,DE
	POP HL
	
	CALL DrawJewel
	
	POP DE
	POP BC
	POP HL
	
	INC DE					;next jewel data
	INC HL
	INC HL
	INC HL
	INC HL					;poisition of next jewel
	
	
	DJNZ DrawPassword2
	RET
	
	
;---------------	
MoveSound
	HALT
	PUSH BC
	LD C,7				
MoveSound2
	XOR A
	OUT (254),A
	LD B,10
MoveSound3
	NOP
	NOP
	NOP
	DJNZ MoveSound3
	LD A,16
	OUT (254),A
	DEC C
	JR NZ, MoveSound2

	LD B,8
MoveSound4
	HALT
	DJNZ MoveSound4	
	POP BC
	RET	
	
;---------------
SelectionSound
	LD C,7				
SelectionSound2
	XOR A
	OUT (254),A
	LD B,40
SelectionSound3
	PUSH BC
	POP BC	
	DJNZ SelectionSound3
	LD A,16
	OUT (254),A
	DEC C
	JR NZ, SelectionSound2

	LD B,20
SelectionSound4
	HALT
	DJNZ SelectionSound4
	RET	
	
;-----------------
FinalSound
	XOR A
	LD B,150
	LD D,100

FinalSound2
	LD E,D
FinalSound3
	DEC E
	JR NZ,FinalSound3
	
	XOR 16
	OUT (254),A
	
	DEC D
	DEC D

	LD E,D
FinalSound4
	DEC E
	JR NZ,FinalSound4
	
	DJNZ FinalSound2
	
	RET

	
	
;-----------------	
Wait
	HALT
	DJNZ Wait	
	RET

	
;----------------------
ClearScreen_Effect
	LD HL,22528				;corner
	LD DE,32
	LD B,31
	LD C,23					;initial dimmentions

ClearScreen_Effect4
	HALT
	HALT
	HALT
	HALT
	PUSH HL
	PUSH BC
	XOR A
	
;clear one ring		
	PUSH BC	
ClearScreen_Effect5				;right
	LD (HL),A
	INC HL
	DJNZ ClearScreen_Effect5
	
ClearScreen_Effect6				;down
	LD (HL),A
	ADD HL,DE
	DEC C
	JR NZ,ClearScreen_Effect6
	POP BC
	
ClearScreen_Effect7				;left
	LD (HL),A
	DEC HL
	DJNZ ClearScreen_Effect7
	
ClearScreen_Effect8				;up
	LD (HL),A
	SUB HL,DE
	DEC C
	JR NZ,ClearScreen_Effect8

;ring clearing is finished
	POP BC
	POP HL
;go to deeper ring
	ADD HL,DE					;corner
	INC HL
			
	DEC B						;sizes
	DEC B
	DEC C
	DEC C
	LD A,C
	CP 255
	JR NZ,ClearScreen_Effect4
	RET

	
	
;----------------------------------	
EnterPassword
	CALL ClearScreen
	LD A,3
	LD (CursorPos),A

;set password to 1,1,1,1
	LD DE,Password
	LD A,1
	LD B,4
EnterPassword2
	LD (DE),A
	INC DE
	DJNZ EnterPassword2		
	
;draw password jewels for the 1st time
	
EnterPassword21
	LD DE,Password
	CALL EnterPassword_Draw
	
	CALL EnterPassword_DrawCursor
	
	
EnterPassword3
	LD B,8
EnterPassword31
	HALT
	DJNZ EnterPassword31
	
	CALL GetPlayerInput

;right		
	BIT 0,A
	JR Z,EnterPassword4	
	
	LD A,(CursorPos)
	CP 4
	JR Z,EnterPassword3		;edge
	INC A
	LD (CursorPos),A
	JR EnterPassword21
	
;left	
EnterPassword4	
	BIT 1,A
	JR Z,EnterPassword5	
	
	LD A,(CursorPos)
	CP 1
	JR Z,EnterPassword3		;edge
	DEC A
	LD (CursorPos),A
	JR EnterPassword21

;down
EnterPassword5
	BIT 2,A	
	JR Z,EnterPassword6
	
	LD HL,Password-1
	LD A,(CursorPos)
EnterPassword51				;find position
	INC HL
	DEC A
	JR NZ,EnterPassword51
	
	LD A,(HL)
	CP 10
	JR Z,EnterPassword3		;last jewel
	INC (HL)				;change - next jewel
	JR EnterPassword21
	
;up	
EnterPassword6	
	BIT 3,A	
	JR Z,EnterPassword7
	
	LD HL,Password-1
	LD A,(CursorPos)
EnterPassword61				;find position
	INC HL
	DEC A
	JR NZ,EnterPassword61
	
	LD A,(HL)
	CP 1
	JR Z,EnterPassword3		;first jewel
	DEC (HL)				;change - previous jewel
	JR EnterPassword21

;fire - end?
EnterPassword7
	BIT 4,A
	JP Z,EnterPassword3		;nothing pressed, repeat

;confirm password	
	LD HL,PasswordData
	LD B,1					;nr of level
EnterPassword8
	PUSH HL
	LD DE,Password
	LD C,4	
EnterPassword9
	LD A,(DE)
	CP (HL)
	JR NZ,EnterPassword10	;password wrong for checked level
	INC HL
	INC DE
	DEC C					;check next symbol
	JR NZ,EnterPassword9

;password correct
	LD A,B
	LD (LevelNr),A
	JP Start1				;go to level
	

EnterPassword10
	POP HL					;go to next level
	INC HL
	INC HL
	INC HL
	INC HL
	INC B
	LD A,B
	CP 31					;going over last level?
	JR NZ,EnterPassword8
	
;password wrong	
	LD HL,20480+40
	LD DE,PswdWrongText
	CALL TypeText
	CALL FinalSound
	LD B,100
	CALL Wait
	JP StartMenu	
	
;----
EnterPassword_Draw
	LD HL,18432+136
	LD B,4
	CALL DrawPassword2
	RET		

;----		
EnterPassword_DrawCursor
;clear line
	LD HL,18432+232					
	LD B,14
	XOR A
EnterPassword_DrawCursor2
	LD (HL),A	
	INC HL
	DJNZ EnterPassword_DrawCursor2
;find cursor pos
	LD HL,18432+232-4
	LD DE,4
	LD A,(CursorPos)
EnterPassword_DrawCursor3
	ADD HL,DE
	DEC A
	JR NZ,EnterPassword_DrawCursor3
;draw cursor
	LD A,85
	LD (HL),A
	INC HL
	LD (HL),A
	RET		
	
Password	.BYTE 0,0,0,0
CursorPos	.BYTE 0