	DEVICE ZXSPECTRUM48

	ORG 24000

Start0
	CALL 49152				;music after loading screen	
	
Start
	DI	
	LD SP,65000
	EI
	
	CALL StartMenu			;draw game menu and return here after chosing the game start
	CALL ClearScreen_Effect
	
	LD A,1			;set game variables
	LD (LevelNr),A
	
Start1	
	LD A,5
	LD (Lives),A
	
	XOR A
	LD A,0
	LD (Score),A
	
	JP NewLevel			;display "LEVEL NN" text + set some data and return here

;beginning a new level	
Start2	
	DI	
	LD SP,65000
	EI
	
	CALL ClearScreen

	CALL CopyBackground
	
	CALL DrawBorder
	
	CALL SetLevel			;read level data
	CALL DrawLevel			;draw jewels
	
	CALL DrawCursor

MainLoop
	HALT
	
	LD A,174
	LD (DrawCursor_SMD),A	;XOR (HL) for clearing
	CALL DrawCursor			;clear cursor at old position
	
	CALL MoveCursor
	
	CALL CheckWin
	
	LD A,182
	LD (DrawCursor_SMD),A	;OR (HL) for drawing
	CALL DrawCursor			;draw cursor at new position
	
	CALL MarkSelectedJewel	
	
	CALL CheckGiveUp
	CALL CheckQuit
	
	LD A,(PlayerInput)		;test joystick, if moving cursor play sound
	BIT 4,A
	JR NZ,MainLoop2			;no move sound, for selection
	
	OR A
	CALL NZ,MoveSound

MainLoop2
	JP MainLoop	
	

PlayerInput			.BYTE 0
	
CursorX				.BYTE 0
CursorY				.BYTE 0
CursorHL			.WORD 0

LevelNr				.BYTE 0
BackgroundColor		.BYTE 0

CurrentLevelData	.WORD 0

BorderCorner		.WORD 0
BoardPos	.WORD 0

BoardSize	.BYTE 0				;side (6,8,9)
BoardSize2	.BYTE 0				;nr of jewels (36,64,81)

								
SelectedJewel		.BYTE 0		;nr of selected jewel (0 - no first jewel selected)								
SelectedX			.BYTE 0
SelectedY			.BYTE 0

Lives				.BYTE 4
Score				.BYTE 0

GameControl			.BYTE 0		;0-keys,1-kempston,2-sinclair

	INCLUDE <Graphics.asm>					
	INCLUDE <Logic.asm>
	INCLUDE <Logic2.asm>
	INCLUDE <Text.asm>
	INCLUDE <Menu.asm>
	INCLUDE <Levels.asm>
	
	ORG 49152	
	INCBIN <ReductMusic.bin>
	
	SAVESNA "Reduct.sna",Start0