TypeText	

;HL; contains position of text on screen
;DE contains text address in memory
;BC is used		

	;Default text color is white on black
	LD A,70
	LD (TextColor),A
		
	LD (TextLineAd),HL
	
TypeText2	
	;Check if end of string
	LD A,(DE)
	AND A
	RET Z 								;end of text if zero
	
	CP 50								;checks if should go to new line
	JR Z,TextNewLine
	CP 51								;checks if color change
	JR Z,TextColorChange
										;letter attribute	
	PUSH HL
	LD A,80
	SRL H
	SRL H
	SRL H
	ADD A,H
	LD H,A
	LD A,(TextColor)
	LD (HL),A
	POP HL
	
;draw a letter
	LD A,(DE)							;code of letter loaded
	LD BC,Letters-8						;start of letters sprites
	
;Count address of letter
	SLA A
	SLA A
	SLA A								;A=A*8 (with carry)to count adress of letter		
	
	PUSH HL
	LD HL,0
		
	LD L,A
	LD A,0
	ADC A,H	
	LD H,A								;HL=A*8	
	ADD HL,BC
	LD B,H
	LD C,L								;BC loaded with letter sprite address
	POP HL
	
	PUSH HL
	PUSH DE
	LD E,8
	
Text3
	LD A,(BC)							;read letter data
	LD (HL),A							;and print it in screen		
	INC H
	INC BC								;go to next byte
	DEC E
	JR NZ, Text3
	POP DE
	POP HL

;go to next letter			
	INC L								;next char on the screen
	INC DE 								;next letter
	JR TypeText2
	
		
TextNewLine
;go one line down	with text
	LD HL,(TextLineAd)					;beginning of current line IN HL
	CALL OneCharDown					;count address of one line down AND place it IN HL
	LD (TextLineAd),HL					;Update value
	INC DE								;Next letter
	JR TypeText2						;go to letter printing routine
	
TextColorChange
	INC DE
	LD A,(DE)							;read new color
	LD (TextColor),A					;AND write it to proper cell			
	INC DE								;go to next letter
	JR TypeText2		

TextColor .BYTE 71						;text attribute
TextLineAd .WORD 16384					;screen address 
			   							;of currently printed text line (address of 1st char)	

Letters
	.BYTE	  0, 60,102,102,126,102,102,102;A 1
	.BYTE	  0,126, 51, 51, 62, 51, 51,126;B
	.BYTE	  0, 31, 49, 48, 48, 48, 49, 31;C
	.BYTE	  0,124, 54, 51, 51, 51, 54,124;D
	.BYTE	  0,127, 49, 52, 60, 52, 49,127;E
	.BYTE	  0,127, 49, 52, 60, 52, 48,120;F
	.BYTE	  0, 30, 51, 96, 96,103, 51, 31;G
	.BYTE	  0, 51, 51, 51, 63, 51, 51, 51;H
	.BYTE	  0, 63, 12, 12, 12, 12, 12, 63;I
	.BYTE	  0, 15,  6,  6,  6,102,102, 60;J
	.BYTE	  0,115, 51, 54, 60, 54, 51,115;K
	.BYTE	  0,120, 48, 48, 48, 49, 51,127;L
	.BYTE	  0, 99,119,127,127,107, 99, 99;M
	.BYTE	  0, 99,115,123,111,103, 99, 99;N
	.BYTE	  0, 62, 99, 99, 99, 99, 99, 62;O
	.BYTE	  0,126, 51, 51, 62, 48, 48,120;P
	.BYTE	  0, 62, 99, 99,107,101, 98, 59;Q
	.BYTE	  0,126, 51, 51, 62, 54, 51,115;R
	.BYTE	  0, 30, 51, 48, 30,  3, 51, 30;S
	.BYTE	  0, 63, 45, 12, 12, 12, 12, 30;T
	.BYTE	  0, 51, 51, 51, 51, 51, 51, 30;U
	.BYTE	  0, 51, 51, 51, 51, 51, 30, 12;V
	.BYTE	  0, 99, 99, 99,107,127,119, 99;W
	.BYTE	  0,102,126, 60, 24, 60,126,102;X
	.BYTE	  0,102,102,102, 60, 24, 24, 24;Y
	.BYTE	  0,126, 70, 14, 28, 56,114,126;Z - 26
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0;space -  27
	.BYTE	  0,  0,  0,  0,  0,  0, 48, 48;. - 28
	.BYTE	  0, 48, 48, 48, 48, 48,  0, 48;! - 29
Numbers	
	.BYTE	  0, 62, 99,103,107,115, 99, 62;0 - 30
	.BYTE	  0, 24, 56, 24, 24, 24, 24,126
	.BYTE	  0, 60,102,  6, 60, 96,102,126
	.BYTE	  0, 60,102,  6, 28,  6,102, 60
	.BYTE	  0, 12, 28, 44, 76,127, 12, 30
	.BYTE	  0,126, 98, 96,124,  6,102, 60
	.BYTE	  0, 30, 51, 48, 62, 51, 51, 30
	.BYTE	  0, 63, 63,  3,  6, 12, 12, 12
	.BYTE	  0, 60,102,102, 60,102,102, 60
	.BYTE	  0, 60,102,102, 62,  6,102, 60
	.BYTE	  0,120, 48, 56,112, 49, 51,127	;
	
;------------------------------
;texts

LevelTxt		 .BYTE 12,5,22,5,12,27,1,1,0

LevelClearTxt	 .BYTE 51,69,27,23,5,12,12,27,4,15,14,5,29,50,50,51,71,12,5,22,5,12,27,27,3,12,5,1,18,0

LevelFailTxt	.BYTE 51,69,27,25,15,21,27,6,1,9,12,50,50,51,71,25,15,21,27,8,1,22,5,27,1,50,20,18,9,5,19,27,12,5,6,20,0

MenuText		 .BYTE 51,65,27,18,5,4,21,3,20,9,15,27,1,4,27,14,9,8,9,12,21,13,50,50,27,27,27,27,51,71,31,28,27,11,5,25,2
				 .BYTE 15,1,18,4,50,27,27,27,27,32,28,27,11,5,13,16,19,20,15,14,50,27,27,27,27,33,28,27,19,9,14,3,12,1,9,18,50,27,27,27,27,34,28,27,16,1,19,19,23,15,18,4,50,27,27,27,27,35,28,27,19,20,1,18,20,50,50,50,51,69,7,1,13,5,27,2,25,27,27,18,1,6,1,40,27,13,9,1,26,7,1,50
				 .BYTE 13,21,19,9,3,27,2,25,27,27,13,9,19,20,5,18,27,2,5,5,16,50
				  .BYTE 8,5,12,16,27,2,25,27,27,5,9,14,1,18,27,19,1,21,11,1,19,50,50
				 
				 .BYTE 27,27,27,27,27,27,27,27,32,30,31,31,0
				 
BonusText		 .BYTE 51,69,2,15,14,21,19,27,1,30,30,0

ScoreText		 .BYTE 51,65,19,3,15,18,5,27,1,1,1,30,30,0

WinText			 .BYTE 51,1,27,27,27,27,3,15,14,7,18,1,20,21,12,1,20,9,15,14,19,50,50,51,71,25,15,21,27,8,1,22,5,27,3,15,13,16,12,5,20,5,4
				 .BYTE 27,25,15,21,18,50,27,20,18,1,9,14,9,14,7,27,1,14,4,27,21,14,22,5,9,12,5,4,50,27,27,20,8,5,27,5,20,5,18,14,1
				 .BYTE 12,27,12,1,23,19,27,15,6,50,27,27,27,21,14,9,22,5,18,19,1,12,27,8,1,18,13,15,14,25,50,50,14,15,23,27,25,15
				 .BYTE 21,27,8,1,22,5,27,20,18,5,13,5,14,4,15,21,19,50,27,13,1,7,9,3,27,16,15,23,5,18,19,28,21,19,5,27,20,8,5,13
				 .BYTE 50,27,27,9,14,27,7,15,15,4,27,3,1,21,19,5,27,15,14,12,25,29,0
				 
GameOverText	 .BYTE 7,1,13,5,27,15,22,5,18,0

PswdWrongText	 .BYTE 51,66,23,18,15,14,7,27,16,1,19,19,23,15,18,4,0


